
Const count_brushes% = 7
Global brush:TImage[count_brushes]
create_brushes()

Function create_brushes()

	SetClsColor 0,0,0

	Local count%, size%, x#, y#, temp_size#, half_size#, white_alpha%
	
	
	size = ScreenSize / 4.0
	half_size = 0.5*size
	
	'------------- weicher Kreis: ------------------------------
	
	Cls
	For x = 0 Until half_size
		white_alpha = 255.0 * (x+1) / half_size
		SetColor white_alpha, white_alpha, white_alpha
		temp_size = size - size * x / half_size
		DrawOval x, x, temp_size, temp_size
	Next
	brush[0] = GrabAlphaImage(size,size)

	'------------- weiches Diamantquadrat: ---------------------

	Cls
	For x = 0 Until half_size
		white_alpha = 255.0 * (x+1) / half_size
		SetColor white_alpha, white_alpha, white_alpha
		temp_size = size - size * x / half_size
		DrawRect x, x, temp_size, temp_size
	Next
	brush[1] = GrabAlphaImage(size,size)

	'------------- weicher Stern: -------------------------------

	Cls
	For x = 0 Until half_size
		white_alpha = 255.0 * (x+1) / half_size
		SetColor white_alpha, white_alpha, white_alpha
		temp_size = 0.375 * (size - size * x / half_size)
		DrawPoly( [x, half_size, x + temp_size, size - x - temp_size, x + temp_size, x + temp_size] )
		DrawPoly( [half_size, size - x, size - x - temp_size, size - x - temp_size, x + temp_size, size - x - temp_size] )
		DrawPoly( [size - x, half_size, size - x - temp_size, x + temp_size, size - x - temp_size, size - x - temp_size] )
		DrawPoly( [half_size, x, x + temp_size, x + temp_size, size - x - temp_size, x + temp_size] )
		DrawRect x + temp_size, x + temp_size, size - x - temp_size - x - temp_size, size - x - temp_size - x - temp_size
	Next
	brush[2] = GrabAlphaImage(size,size)
	
	'------------- weicher Ring: -------------------------------
	
	Cls
	For x = 0 Until 0.25*half_size
		white_alpha = 255.0 * (x+1) / (0.25*half_size)
		SetColor white_alpha, white_alpha, white_alpha
		temp_size = size - size * x / half_size
		DrawOval x, x, temp_size, temp_size
	Next
	For x = 0.25*half_size Until 0.5*half_size
		white_alpha = 255.0 - 255.0 * (x+1 - 0.25*half_size) / (0.25*half_size)
		SetColor white_alpha, white_alpha, white_alpha
		temp_size = size - size * x / half_size
		DrawOval x, x, temp_size, temp_size
	Next
	brush[3] = GrabAlphaImage(size,size)
	
	'------------- weicher Quadratrahmen: ---------------------
	
	Cls
	For x = 0 Until 0.25*half_size
		white_alpha = 255.0 * (x+1) / (0.25*half_size)
		SetColor white_alpha, white_alpha, white_alpha
		temp_size = size - size * x / half_size
		DrawRect x, x, temp_size, temp_size
	Next
	For x = 0.25*half_size Until 0.5*half_size
		white_alpha = 255.0 - 255.0 * (x+1 - 0.25*half_size) / (0.25*half_size)
		SetColor white_alpha, white_alpha, white_alpha
		temp_size = size - size * x / half_size
		DrawRect x, x, temp_size, temp_size
	Next
	brush[4] = GrabAlphaImage(size,size)
	
	'--- viele harte kleine zufaellig kreisfoermig angeordnete Dreiecke: ---
	
	Cls
	SetColor 255,255,255
	count = 0.3*size
	temp_size = 0.03 * size
	For Local i% = 0 Until count
		Local radius% = Rand(0, 0.9*half_size)
		Local angle% = Rand(0,359)
		x = half_size + radius * Cos(angle)
		y = half_size + radius * Sin(angle)
		angle = Rand(0,359)
		DrawPoly([x+temp_size*Float(Cos(angle)), y+temp_size*Float(Sin(angle)), x+temp_size*Float(Cos(angle+120)), y+temp_size*Float(Sin(angle+120)), x+temp_size*Float(Cos(angle-120)), y+temp_size*Float(Sin(angle-120))])
	Next
	brush[5] = GrabMaskedImage(size,size)
	
	'--- noch mehr harte noch kleinere regelmaessig kreisfoermig angeordnete Punkte (Quadrate): ---
	
	Cls
	temp_size = half_size*half_size
	For x = 0 Until size Step 6
		For y = 0 Until size Step 6
			If (x-half_size)*(x-half_size) + (y-half_size)*(y-half_size) <= temp_size Then DrawRect x, y, 2, 2
		Next
	Next
	brush[6] = GrabMaskedImage(size,size)

	'--------------------------------------------------------
	Cls

End Function


'############################################################################

Function GrabAlphaImage:TImage(sizeX%, sizeY%, left_x% = 0, top_y% = 0)
	Local Grabbed_PM:TPixmap = GrabPixmap(left_x,top_y,sizeX,sizeY)
	Local Alpha_PM:TPixmap = CreatePixmap(sizeX, sizeY, PF_BGRA8888)
	For Local x% = 0 Until sizeX
		For Local y% = 0 Until sizeY
			Local ARGB% = ReadPixel(Grabbed_PM, x, y)
			Local alpha_value% = (ARGB & $00FF0000:Int) / $10000:Int
			ARGB = alpha_value*$1000000:Int+16777215
			WritePixel(Alpha_PM, x, y, ARGB)
		Next
	Next
	Return LoadImage(Alpha_PM)
End Function

Function GrabMaskedImage:TImage(sizeX%, sizeY%, left_x% = 0, top_y% = 0)
	Local Grabbed_PM:TPixmap = GrabPixmap(left_x,top_y,sizeX,sizeY)
	Local Masked_PM:TPixmap = CreatePixmap(sizeX, sizeY, PF_BGRA8888)
	For Local x% = 0 Until sizeX
		For Local y% = 0 Until sizeY
			Local ARGB% = ReadPixel(Grabbed_PM, x, y)
			If ARGB = -16777216 Then
				WritePixel(Masked_PM, x, y, 0)
			Else
				WritePixel(Masked_PM, x, y, ARGB)
			End If
		Next
	Next
	Return LoadImage(Masked_PM)
End Function


Global Red@[192,63], Green@[192,63], Blue@[192,63]
For Local i@ = 0 To 31
	Red[i, 31] = 255
	Green[i, 31] = i*8
	Red[32+i, 31] = 255 - i*8
	Green[32+i, 31] = 255
	Green[64+i, 31] = 255
	Blue[64+i, 31] = i*8
	Green[96+i, 31] = 255 - i*8
	Blue[96+i, 31] = 255
	Blue[128+i, 31] = 255
	Red[128+i, 31] = i*8
	Blue[160+i, 31] = 255 - i*8
	Red[160+i, 31] = 255
Next
For Local i@ = 0 To 191
	For Local j@ = 1 To 31
		Red[i,31-j] = Max(0, Red[i,31] - j*8)
		Red[i,31+j] = Min(255, Red[i,31] + j*8)
		Green[i,31-j] = Max(0, Green[i,31] - j*8)
		Green[i,31+j] = Min(255, Green[i,31] + j*8)
		Blue[i,31-j] = Max(0, Blue[i,31] - j*8)
		Blue[i,31+j] = Min(255, Blue[i,31] + j*8)
	Next
Next